# Roo Code 3.15.0 Release Notes (2025-04-30)

This release introduces prompt caching for Google Vertex, improved terminal command handling, UI/UX enhancements, and several other improvements and bug fixes.

## Prompt Caching for Google Vertex

*   Added prompt caching capabilities to the Google Vertex provider for potentially faster and more cost-effective responses (thanks ashktn).

## Improved Terminal Command Handling

*   Implemented a [fallback mechanism](/features/shell-integration#command-execution-fallback) for executing terminal commands if VSCode terminal shell integration fails.
*   Added the ability to stop commands directly from the chat UI.

    <img src="/img/v3.15.0/v3.15.0-2.png" width="600" />

## Settings Import/Export

*   Roo Code settings can now be imported directly from the welcome screen (thanks julionav).

    <img src="/img/v3.15.0/v3.15.0-1.png" width="600" />

*   Fixed importing & exporting of custom modes (thanks julionav).

## QOL Improvements

*   Improved the UI/UX of code snippets in the chat (thanks KJ7LNW).
*   Adjusted chat view padding to accommodate small width layouts (thanks zhangtony239).
*   Simplified and streamlined Roo Code's [quick actions](/features/code-actions).

    <img src="/img/v3.15/v3.15-1.png" width="350" />

*   Improved the auto-approve toggle buttons for some high-contrast VSCode themes.
*   Offloaded expensive count token operations to a web worker for better performance (thanks samhvw8).
*   Improved support for multi-root workspaces (thanks snoyiatk).
*   Improved the performance of mode switching (thanks dlab-anton).

## Bug Fixes

*   Fixed file mentions for filenames containing spaces.
*   Fixed importing & exporting of custom modes (thanks julionav).

## Provider Updates

*   **Google Vertex:** Added prompt caching (thanks ashktn).
*   **OpenAI Compatible:** Added a reasoning effort setting (thanks mr-ryan-james).

## Misc Improvements

*   Removed unused types (thanks wkordalski).