# Roo Code 3.8.5 Release Notes (2025-03-12)

This release introduces significant refactoring, remote browser support, MCP over SSE, and various provider/model updates.

## Feature Highlights

*   **Terminal Architecture Refactor:** Addressed critical issues with the terminal architecture for improved stability and performance. (thanks KJ7LNW!)
*   **MCP over SSE:** Added support for Model Context Protocol (MCP) communication over Server-Sent Events (SSE). (thanks aheizi!)
*   **Remote Browser Support:** Added the ability to connect to a remote Chrome browser instance. (thanks afshawnlotfi!)

## Provider & Model Support

*   Added custom `baseUrl` support for Google AI Studio Gemini. (thanks dqroid!)
*   Added OpenAI-compatible DeepSeek/QwQ reasoning support. (thanks lightrabbit!)
*   Added Anthropic-style prompt caching in the OpenAI-compatible provider. (thanks dleen!)
*   Added Deepseek R1 model for AWS Bedrock. (thanks ATempsch!)
*   Added `gemini-2.0-pro-exp-02-05` model to Vertex AI provider. (thanks shohei-ihaya!)
*   Added support for custom ARNs in AWS Bedrock. (thanks Smartsheet-JB-Brown!)
*   Updated Bedrock prices to the latest. (thanks Smartsheet-JB-Brown!)

## Improvements & Fixes

*   Preserved parent-child relationship when cancelling Boomerang Tasks (subtasks). (thanks cannuri!)
*   Added PowerShell-specific command handling. (thanks KJ7LNW!)
*   Fixed MarkdownBlock text color for Dark High Contrast theme. (thanks cannuri!)
*   Brought back progress status indicator for multi-diff edits. (thanks qdaxb!)
*   Refactored alert dialog styles to use the correct VSCode theme. (thanks cannuri!)
*   Updated MCP servers directory path for platform compatibility. (thanks hannesrudolph!)
*   Fixed browser system prompt inclusion rules. (thanks cannuri!)
*   Fixed OpenAI-style cost calculations. (thanks dtrugman!)
*   Fixed issue allowing use of an excluded directory as the working directory. (thanks Szpadel!)
*   Added Kotlin language support in `list_code_definition_names` tool. (thanks kohii!)
*   Improved handling of diff application errors. (thanks qdaxb!)
*   Fixed OpenRouter custom `baseUrl` support.
*   Fixed usage tracking for SiliconFlow and other providers that include usage on every chunk.
*   Added telemetry for checkpoint save/restore/diff and diff strategies.
*   Published git tags to GitHub from CI. (thanks pdecat!)